Index: django/conf/locale/uk/formats.py
===================================================================
--- django/conf/locale/uk/formats.py	(revision 14469)
+++ django/conf/locale/uk/formats.py	(working copy)
@@ -2,9 +2,9 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'j F Y р.'
+DATE_FORMAT = 'j E Y р.'
 TIME_FORMAT = 'H:i:s'
-# DATETIME_FORMAT = 
+DATETIME_FORMAT = 'j E Y р. H:i:s'
 YEAR_MONTH_FORMAT = 'F Y'
 MONTH_DAY_FORMAT = 'j F'
 SHORT_DATE_FORMAT = 'j M Y'
Index: django/conf/locale/uk/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/uk/LC_MESSAGES/django.po	(revision 14469)
+++ django/conf/locale/uk/LC_MESSAGES/django.po	(working copy)
@@ -4565,6 +4565,66 @@
 msgid "Dec."
 msgstr "Груд."
 
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "January"
+msgstr "січня"
+
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "February"
+msgstr "лютого"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "March"
+msgstr "березня"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "April"
+msgstr "квітня"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "May"
+msgstr "травня"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "June"
+msgstr "червня"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "July"
+msgstr "липня"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "August"
+msgstr "серпня"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "September"
+msgstr "вересня"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "October"
+msgstr "жовтня"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "November"
+msgstr "листопада"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "December"
+msgstr "грудня"
+
 #: .\utils\text.py:128
 msgid "or"
 msgstr "або"
Index: django/conf/locale/fi/formats.py
===================================================================
--- django/conf/locale/fi/formats.py	(revision 14469)
+++ django/conf/locale/fi/formats.py	(working copy)
@@ -2,7 +2,7 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'j. F Y'
+DATE_FORMAT = 'j. E Y'
 TIME_FORMAT = 'G.i.s'
 # DATETIME_FORMAT = 
 YEAR_MONTH_FORMAT = 'F Y'
Index: django/conf/locale/fi/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/fi/LC_MESSAGES/django.po	(revision 14469)
+++ django/conf/locale/fi/LC_MESSAGES/django.po	(working copy)
@@ -5028,6 +5028,66 @@
 msgid "Dec."
 msgstr "joulu"
 
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "January"
+msgstr "tammikuuta"
+
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "February"
+msgstr "helmikuuta"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "March"
+msgstr "maaliskuuta"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "April"
+msgstr "huhtikuuta"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "May"
+msgstr "toukokuuta"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "June"
+msgstr "kesäkuuta"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "July"
+msgstr "heinäkuuta"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "August"
+msgstr "elokuuta"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "September"
+msgstr "syyskuuta"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "October"
+msgstr "lokakuuta"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "November"
+msgstr "marraskuuta"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "December"
+msgstr "joulukuuta"
+
 #: utils/text.py:130
 msgid "or"
 msgstr "tai"
Index: django/conf/locale/ru/formats.py
===================================================================
--- django/conf/locale/ru/formats.py	(revision 14469)
+++ django/conf/locale/ru/formats.py	(working copy)
@@ -2,9 +2,9 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'j F Y г.'
+DATE_FORMAT = 'j E Y г.'
 TIME_FORMAT = 'G:i:s'
-DATETIME_FORMAT = 'j F Y г. G:i:s'  
+DATETIME_FORMAT = 'j E Y г. G:i:s'  
 YEAR_MONTH_FORMAT = 'F Y г.'
 MONTH_DAY_FORMAT = 'j F'
 SHORT_DATE_FORMAT = 'd.m.Y'
Index: django/conf/locale/ru/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/ru/LC_MESSAGES/django.po	(revision 14469)
+++ django/conf/locale/ru/LC_MESSAGES/django.po	(working copy)
@@ -4929,6 +4929,66 @@
 msgid "Dec."
 msgstr "Дек."
 
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "January"
+msgstr "января"
+
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "February"
+msgstr "февраля"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "March"
+msgstr "марта"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "April"
+msgstr "апреля"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "May"
+msgstr "мая"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "June"
+msgstr "июня"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "July"
+msgstr "июля"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "August"
+msgstr "августа"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "September"
+msgstr "сентября"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "October"
+msgstr "октября"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "November"
+msgstr "ноября"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "December"
+msgstr "декабря"
+
 #: utils/text.py:130
 msgid "or"
 msgstr "или"
Index: django/conf/locale/cs/formats.py
===================================================================
--- django/conf/locale/cs/formats.py	(revision 14469)
+++ django/conf/locale/cs/formats.py	(working copy)
@@ -2,9 +2,9 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'j. F Y'
+DATE_FORMAT = 'j. E Y'
 TIME_FORMAT = 'G:i:s'
-DATETIME_FORMAT = 'j. F Y G:i:s'
+DATETIME_FORMAT = 'j. E Y G:i:s'
 YEAR_MONTH_FORMAT = 'F Y'
 MONTH_DAY_FORMAT = 'j. F'
 SHORT_DATE_FORMAT = 'd.m.Y'
Index: django/conf/locale/cs/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/cs/LC_MESSAGES/django.po	(revision 14469)
+++ django/conf/locale/cs/LC_MESSAGES/django.po	(working copy)
@@ -5057,6 +5057,66 @@
 msgid "Dec."
 msgstr "prosinec"
 
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "January"
+msgstr "ledna"
+
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "February"
+msgstr "února"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "March"
+msgstr "března"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "April"
+msgstr "dubna"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "May"
+msgstr "května"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "June"
+msgstr "června"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "July"
+msgstr "července"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "August"
+msgstr "srpna"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "September"
+msgstr "září"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "October"
+msgstr "října"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "November"
+msgstr "listopadu"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "December"
+msgstr "prosince"
+
 #: utils/text.py:130
 msgid "or"
 msgstr "nebo"
Index: django/conf/locale/hr/formats.py
===================================================================
--- django/conf/locale/hr/formats.py	(revision 14469)
+++ django/conf/locale/hr/formats.py	(working copy)
@@ -2,9 +2,9 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'j. F Y.'
+DATE_FORMAT = 'j. E Y.'
 TIME_FORMAT = 'H:i:s'
-DATETIME_FORMAT = 'j. F Y. H:i'
+DATETIME_FORMAT = 'j. E Y. H:i'
 YEAR_MONTH_FORMAT = 'F Y.'
 MONTH_DAY_FORMAT = 'j. F'
 SHORT_DATE_FORMAT = 'j.m.Y.'
Index: django/conf/locale/hr/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/hr/LC_MESSAGES/django.po	(revision 14469)
+++ django/conf/locale/hr/LC_MESSAGES/django.po	(working copy)
@@ -5082,6 +5082,66 @@
 msgid "Dec."
 msgstr "Pro."
 
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "January"
+msgstr "siječnja"
+
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "February"
+msgstr "veljače"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "March"
+msgstr "ožujka"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "April"
+msgstr "travnja"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "May"
+msgstr "svibnja"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "June"
+msgstr "lipnja"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "July"
+msgstr "srpnja"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "August"
+msgstr "kolovoza"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "September"
+msgstr "rujna"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "October"
+msgstr "listopada"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "November"
+msgstr "studenoga"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "December"
+msgstr "prosinca"
+
 #: utils/text.py:130
 msgid "or"
 msgstr "ili"
Index: django/conf/locale/pl/formats.py
===================================================================
--- django/conf/locale/pl/formats.py	(revision 14469)
+++ django/conf/locale/pl/formats.py	(working copy)
@@ -2,9 +2,9 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'j F Y'
+DATE_FORMAT = 'j E Y'
 TIME_FORMAT = 'H:i:s'
-DATETIME_FORMAT = 'j F Y H:i:s'
+DATETIME_FORMAT = 'j E Y H:i:s'
 YEAR_MONTH_FORMAT = 'F Y'
 MONTH_DAY_FORMAT = 'j F'
 SHORT_DATE_FORMAT = 'd-m-Y'
Index: django/conf/locale/pl/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/pl/LC_MESSAGES/django.po	(revision 14469)
+++ django/conf/locale/pl/LC_MESSAGES/django.po	(working copy)
@@ -5166,6 +5166,66 @@
 msgid "Dec."
 msgstr "Gru."
 
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "January"
+msgstr "stycznia"
+
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "February"
+msgstr "lutego"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "March"
+msgstr "marca"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "April"
+msgstr "kwietnia"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "May"
+msgstr "maja"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "June"
+msgstr "czerwca"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "July"
+msgstr "lipca"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "August"
+msgstr "sierpnia"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "September"
+msgstr "września"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "October"
+msgstr "października"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "November"
+msgstr "listopada"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "December"
+msgstr "grudnia"
+
 #: utils/text.py:136
 msgid "or"
 msgstr "lub"
Index: django/conf/locale/el/formats.py
===================================================================
--- django/conf/locale/el/formats.py	(revision 14469)
+++ django/conf/locale/el/formats.py	(working copy)
@@ -2,7 +2,7 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'd F Y'
+DATE_FORMAT = 'd E Y'
 TIME_FORMAT = 'g:i:s A'
 # DATETIME_FORMAT = 
 YEAR_MONTH_FORMAT = 'F Y'
Index: django/conf/locale/el/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/el/LC_MESSAGES/django.po	(revision 14469)
+++ django/conf/locale/el/LC_MESSAGES/django.po	(working copy)
@@ -436,6 +436,66 @@
 msgid "Dec."
 msgstr "Δεκ."
 
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "January"
+msgstr "Ιανουαρίου"
+
+#: utils/dates.py:35
+msgctxt "alt. month"
+msgid "February"
+msgstr "Φεβρουαρίου"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "March"
+msgstr "Μαρτίου"
+
+#: utils/dates.py:36
+msgctxt "alt. month"
+msgid "April"
+msgstr "Απριλίου"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "May"
+msgstr "Μαΐου"
+
+#: utils/dates.py:37
+msgctxt "alt. month"
+msgid "June"
+msgstr "Ιουνίου"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "July"
+msgstr "Ιουλίου"
+
+#: utils/dates.py:38
+msgctxt "alt. month"
+msgid "August"
+msgstr "Αυγούστου"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "September"
+msgstr "Σεπτεμβρίου"
+
+#: utils/dates.py:39
+msgctxt "alt. month"
+msgid "October"
+msgstr "Οκτωβρίου"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "November"
+msgstr "Νοεμβρίου"
+
+#: utils/dates.py:40
+msgctxt "alt. month"
+msgid "December"
+msgstr "Δεκεμβρίου"
+
 #: utils/dateformat.py:40
 msgid "p.m."
 msgstr "μμ."